"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useWindowSize = exports.useMedia = exports.useMasonryColumns = exports.useContainerSizes = exports.useColumnWidths = exports.useColumnSizes = exports.UiFunction = exports.sumPropertyValue = exports.Size = exports.setStorageItem = exports.masonryQueries = exports.isBrowser = exports.getUniqueValues = exports.getUniqueListBy = exports.getStorageItem = exports.getHeaderTags = exports.executeFetchAsync = exports.emptyGuid = exports.defaultQueries = void 0;
const react_1 = __importStar(require("react"));
exports.defaultQueries = [
    '(min-width: 1400px)', '(min-width: 1200px)', '(min-width: 992px)', '(min-width: 768px)', '(min-width: 576px)'
];
exports.emptyGuid = "00000000-0000-0000-0000-000000000000";
async function executeFetchAsync(url, data, bearerToken) {
    if (!exports.isBrowser)
        return;
    const headers = new Headers();
    headers.set('method', (data) ? 'POST' : 'GET');
    headers.set("Content-Type", 'application/json');
    headers.set("contentType", 'application/x-www-form-urlencoded');
    if (bearerToken && bearerToken.length > 0)
        headers.set('Authorization', 'Bearer ' + bearerToken);
    const requestInit = {
        method: (data) ? 'POST' : 'GET',
        headers,
    };
    if (data)
        requestInit.body = JSON.stringify(data);
    const result = await fetch(url, requestInit)
        .then(response => {
        if (response.ok) {
            return response.json();
        }
        else {
            console.warn(response.json());
            return null;
        }
    })
        .then(data => {
        if (!data) {
            console.warn("Connected, however no data from " + url);
            return null;
        }
        if (data.result) {
            return data.result;
        }
        return data;
    })
        .catch(error => {
        console.warn(error);
        return null;
    });
    return result;
}
exports.executeFetchAsync = executeFetchAsync;
function getHeaderTags(hi) {
    const returnValue = react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("title", null, hi.title),
        react_1.default.createElement("link", { rel: "canonical", href: hi.baseUrl + hi.relativePageUrl }),
        react_1.default.createElement("meta", { name: "description", content: hi.description }),
        react_1.default.createElement("meta", { name: "image", content: hi.baseUrl + hi.relativeImageUrl }),
        react_1.default.createElement("meta", { property: "og:url", content: hi.baseUrl + hi.relativePageUrl }),
        react_1.default.createElement("meta", { property: "og:type", content: hi.type }),
        react_1.default.createElement("meta", { property: "og:title", content: hi.title }),
        react_1.default.createElement("meta", { property: "og:description", content: hi.description }),
        react_1.default.createElement("meta", { property: "og:image", content: hi.baseUrl + hi.relativeImageUrl }),
        react_1.default.createElement("meta", { name: "twitter:card", content: "summary_large_image" }),
        react_1.default.createElement("meta", { name: "twitter:creator", content: hi.twitterName }),
        react_1.default.createElement("meta", { name: "twitter:title", content: hi.title }),
        react_1.default.createElement("meta", { name: "twitter:description", content: hi.description }),
        react_1.default.createElement("meta", { name: "twitter:image", content: hi.baseUrl + hi.relativeImageUrl }));
    return returnValue;
}
exports.getHeaderTags = getHeaderTags;
function getStorageItem(key) {
    let returnValue = null;
    if (exports.isBrowser) {
        const storageItem = window.localStorage.getItem(key);
        if (storageItem) {
            returnValue = JSON.parse(storageItem);
        }
    }
    return returnValue;
}
exports.getStorageItem = getStorageItem;
function getUniqueListBy(key, arr1, arr2) {
    const arr = (arr2) ? arr1.concat(arr2) : arr1;
    const result = [];
    const map = new Map();
    for (const item of arr) {
        if (!map.has(item[key])) {
            map.set(item[key], true);
            result.push(item);
        }
    }
    return result;
}
exports.getUniqueListBy = getUniqueListBy;
const getUniqueValues = (items, prop, removeEmpties = true) => {
    let returnValue = [...new Set(items.map((item) => item[prop]))];
    console.log(returnValue);
    if (removeEmpties === true)
        returnValue = returnValue.filter(i => (i && i.length > 0));
    return returnValue;
};
exports.getUniqueValues = getUniqueValues;
exports.isBrowser = typeof window !== "undefined" && window;
exports.masonryQueries = [
    '(min-width: 1650px)', '(min-width: 1375px)', '(min-width: 1100px)', '(min-width: 825px)', '(min-width: 550px)'
];
function setStorageItem(key, obj) {
    const serializedObj = JSON.stringify(obj);
    window.localStorage.setItem(key, serializedObj);
}
exports.setStorageItem = setStorageItem;
var Size;
(function (Size) {
    Size[Size["sm"] = 0] = "sm";
    Size[Size["md"] = 1] = "md";
    Size[Size["lg"] = 2] = "lg";
    Size[Size["xl"] = 3] = "xl";
    Size[Size["xxl"] = 4] = "xxl";
    Size[Size["fluid"] = 5] = "fluid";
})(Size = exports.Size || (exports.Size = {}));
const sumPropertyValue = (items, prop) => items.reduce((a, b) => a + b[prop], 0);
exports.sumPropertyValue = sumPropertyValue;
var UiFunction;
(function (UiFunction) {
    UiFunction[UiFunction["Primary"] = 0] = "Primary";
    UiFunction[UiFunction["Secondary"] = 1] = "Secondary";
    UiFunction[UiFunction["Success"] = 2] = "Success";
    UiFunction[UiFunction["Danger"] = 3] = "Danger";
    UiFunction[UiFunction["Warning"] = 4] = "Warning";
    UiFunction[UiFunction["Info"] = 5] = "Info";
    UiFunction[UiFunction["Light"] = 6] = "Light";
    UiFunction[UiFunction["Dark"] = 7] = "Dark";
    UiFunction[UiFunction["Link"] = 8] = "Link";
})(UiFunction = exports.UiFunction || (exports.UiFunction = {}));
function useColumnSizes(size, colSpan) {
    const collapsedStyle = {
        flexShrink: 0,
        flexBasis: 'auto'
    };
    const expandedStyle = {
        ...collapsedStyle,
        flexGrow: (colSpan > 0) ? '0' : '1',
        width: (colSpan > 0) ? (colSpan / 12) * 100 + '%' : 'auto',
    };
    switch (size) {
        case Size.fluid:
            return useMedia(exports.defaultQueries, [collapsedStyle, collapsedStyle, collapsedStyle, collapsedStyle, collapsedStyle], collapsedStyle);
        case Size.xxl:
            return useMedia(exports.defaultQueries, [expandedStyle, collapsedStyle, collapsedStyle, collapsedStyle, collapsedStyle], collapsedStyle);
        case Size.xl:
            return useMedia(exports.defaultQueries, [expandedStyle, expandedStyle, collapsedStyle, collapsedStyle, collapsedStyle], collapsedStyle);
        case Size.lg:
            return useMedia(exports.defaultQueries, [expandedStyle, expandedStyle, expandedStyle, collapsedStyle, collapsedStyle], collapsedStyle);
        case Size.md:
            return useMedia(exports.defaultQueries, [expandedStyle, expandedStyle, expandedStyle, expandedStyle, collapsedStyle], collapsedStyle);
        default:
            return useMedia(exports.defaultQueries, [expandedStyle, expandedStyle, expandedStyle, expandedStyle, expandedStyle], collapsedStyle);
    }
}
exports.useColumnSizes = useColumnSizes;
function useColumnWidths(width) {
    const queries = [];
    const values = [];
    for (let index = 10; index > 1; index--) {
        queries.push('(min-width: ' + index * width + 'px)');
        values.push(100 / index + '%');
    }
    return useMedia(queries, values, '100%');
}
exports.useColumnWidths = useColumnWidths;
function useContainerSizes(size) {
    switch (size) {
        case Size.fluid:
            return useMedia(exports.defaultQueries, ['100%', '100%', '100%', '100%', '100%'], '100%');
        case Size.xxl:
            return useMedia(exports.defaultQueries, ['1320px', '100%', '100%', '100%', '100%'], '100%');
        case Size.xl:
            return useMedia(exports.defaultQueries, ['1320px', '1140px', '100%', '100%', '100%'], '100%');
        case Size.lg:
            return useMedia(exports.defaultQueries, ['1320px', '1140px', '960px', '100%', '100%'], '100%');
        case Size.md:
            return useMedia(exports.defaultQueries, ['1320px', '1140px', '960px', '720px', '100%'], '100%');
        default:
            return useMedia(exports.defaultQueries, ['1320px', '1140px', '960px', '720px', '540px'], '100%');
    }
}
exports.useContainerSizes = useContainerSizes;
function useMasonryColumns() {
    return useMedia(exports.masonryQueries, [6, 5, 4, 3, 2], 1);
}
exports.useMasonryColumns = useMasonryColumns;
function useMedia(queries, values, defaultValue) {
    if (!exports.isBrowser)
        return defaultValue;
    const mediaQueryLists = queries.map((q) => window?.matchMedia(q));
    const getValue = () => {
        const index = mediaQueryLists.findIndex((mql) => mql.matches);
        return values?.[index] || defaultValue;
    };
    const [value, setValue] = (0, react_1.useState)(getValue);
    (0, react_1.useEffect)(() => {
        const handler = () => setValue(getValue);
        mediaQueryLists.forEach((mql) => mql.addEventListener("change", handler));
        return () => mediaQueryLists.forEach((mql) => mql.removeEventListener("change", handler));
    }, []);
    return value;
}
exports.useMedia = useMedia;
function useWindowSize() {
    const [windowSize, setWindowSize] = (0, react_1.useState)({
        width: exports.isBrowser ? window.innerWidth : 1200,
        height: exports.isBrowser ? window.innerHeight : 800,
    });
    function changeWindowSize() {
        setWindowSize({ width: window.innerWidth, height: window.innerHeight });
    }
    (0, react_1.useEffect)(() => {
        window.addEventListener("resize", changeWindowSize);
        return () => { window.removeEventListener("resize", changeWindowSize); };
    }, []);
    return windowSize;
}
exports.useWindowSize = useWindowSize;
//# sourceMappingURL=index.js.map